import logging
import user_login


class FakeParent:

    class FakeApp:

        class FakeLogin(user_login.UserLogin):

            def __init__(self):
                self.logger = logging.getLogger('FakeLogin')
                self.logger.warning("WARNING! Fake parent created! Use only for debug! WARNING!")
                self.login = "3dpos_user"
                self.profiles = self.load_local_printer_profiles()
                #self.init_profiles()

        def __init__(self):
            self.stop_flag = False
            self.user_login = self.FakeLogin()
            self.local_ip = "127.0.0.1"
            self.offline_mode = True

    def __init__(self):
        self.stop_flag = False
        self.error_history = []
        self.printer = None
        self.parent = self.FakeApp()

    def register_error(self, code, message, *args, **kwargs):
        error_record = {'code': code, 'message': message}
        error_record.update(kwargs)
        self.error_history.append(error_record)
        logging.getLogger("FakeParent").warning(f"Reg error:{error_record}")
        if kwargs.get('is_blocking'):
            self.stop_flag = True
            try:
                self.printer.close()
            except:
                pass
